using Autofac;
using FitConnect.Services;

namespace FitConnect;

public class DiContainer {
    private static IContainer? _container;
    public static Autofac.IContainer Container => _container ??= BuildContainer();

    private static IContainer BuildContainer() {
        var builder = new ContainerBuilder();

        builder.RegisterType<Client>();
        builder.RegisterType<OAuthService>().As<IOAuthService>();
        builder.RegisterType<SubmissionService>().As<ISubmissionService>();
        builder.RegisterType<RouteService>().As<IRouteService>();
        
        

        return builder.Build();
    }
}
