using System.Security.Cryptography.X509Certificates;
using FitConnect.Models;
using FitConnect.Services.Models;
using Microsoft.Extensions.Logging;

namespace FitConnect;

/// <summary>
/// Fluent API for the FitConnect.Subscriber
/// </summary>
public class FluentSubscriber : Subscriber, IFluentApi<FluentSubscriber> {
    private OAuthAccessToken? token;

    public FluentSubscriber(FitConnectEndpoints endpoints, X509Certificate2? certificate = null,
        ILogger? logger = null) : base(endpoints, certificate, logger) {
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="clientId"></param>
    /// <param name="clientSecret"></param>
    /// <param name="scope"></param>
    /// <returns></returns>
    public FluentSubscriber
        Authenticate(string clientId, string clientSecret, string? scope = null) {
        Owner.ClientId = clientId;
        Owner.ClientSecret = clientSecret;

        token ??= AuthenticateAsync(clientId, clientSecret, scope).Result;

        return this;
    }

    public FluentSubscriber GetSubmissions(string destinationId, out List<Submission> submissions) {
        submissions = new List<Submission>();
        throw new NotImplementedException();
    }

    public FluentSubscriber GetSubmission(string destinationId, string submissionId,
        out Submission submission) {
        throw new NotImplementedException();
    }

    public FluentSubscriber PollSubmissions(string destinationId, out int availableSubmissions) {
        throw new NotImplementedException();
    }

    public FluentSubscriber GetAttachments(out object unknown) {
        throw new NotImplementedException();
    }

    public FluentSubscriber DecryptAttachments(out object o) {
        throw new NotImplementedException();
    }

    public FluentSubscriber DecryptData(out object o) {
        throw new NotImplementedException();
    }

    public FluentSubscriber DecryptMetadata(out object o) {
        throw new NotImplementedException();
    }

    public FluentSubscriber ConfirmSubmission() {
        throw new NotImplementedException();
    }
}
